#!/usr/bin/python

import bz2, os

def _pad_int_str(x,n):                           
    s = str(abs(x))
    if x < 0:                           
        return "-" + "0"*(n-len(s)-1) + s
    else:                           
        return "0"*(n-len(s)) + s

def quartic_cm_file(D,A,B):
    Astr = _pad_int_str(A,6)
    Bstr = _pad_int_str(B,8)
    return "../FldCM/4/" + DIR + "/fldcm." + Astr + "." + Bstr + ".dbz"

igusa_degrees = {}
for DIR in os.listdir('.'):
    if DIR != 'Degree' and os.path.isdir(DIR):
        D = int(DIR)
        for FILE in os.listdir(DIR):
            if FILE.split('.')[3] == 'dbz':
                size = os.path.getsize(DIR + '/' + FILE)
                if size == 0:
                    print DIR + '/' + FILE
                else:
                    f = bz2.BZ2File(DIR + '/' + FILE)
                    DAB = FILE.split('.')
                    A = int(DAB[1])
                    B = int(DAB[2])
                    seq = f.read().split('\n')
                    try:
                        quartic_cm_data = bz2.BZ2File(quartic_cm_file(D,A,B)).read().split('\n')
                    except AttributeError:
                        raise AttributeError, "Quartic CM file [%s,%s,%s] does not exist in database."%(D,A,B)
                    h = int(quartic_cm_data[0])
                    h_invs = [ int(hi) for hi in quartic_cm_data[1].strip(' ').split(' ') ]
                    t = int(quartic_cm_data[2])
                    try:  
                        num = int(seq[0])
                    except ValueError:
                        raise ValueError, "File %s must be corrupt (data seq = %s)" % (DIR + '/' + FILE , seq)
                    deg_list = [ ]
                    j = 1                   
                    for i in range(num):
                        deg = int(seq[j])
                        deg_list += [deg]
                        j += 3*(deg+1)+1
                    DAB_degs = ((D,A,B),t,tuple(deg_list),tuple(h_invs))
                    if igusa_degrees.has_key(deg): 
                        igusa_degrees[deg] += [DAB_degs]
                    else:
                        igusa_degrees[deg] = [DAB_degs]
degrees = igusa_degrees.keys()
degrees.sort()
for t in (0,1,2):
    if t == 0:
        print "Biquadratic:"
    if t == 1:
        print "Cylic:"
    if t == 2:
        print "Dihedral:"
    for deg in degrees:
        n = 0
        filename = ''
        for DAB_degs in igusa_degrees[deg]:
            if t == DAB_degs[1]:
                line = "%s %s %s"%DAB_degs[0]
                line += " :"
                for di in DAB_degs[2]:
                    line += " %s"%di
                line += " :"
                for hi in DAB_degs[3]:
                    line += " %s"%hi
                line += "\n"
                if filename == '':
                    filename = 'Degree/degree.' + _pad_int_str(deg,3) + '.' + str(t) + '.db'
                    file = open(filename, 'w')
                file.write(line)
                n += 1
        if filename != '':
            file.close() 
            os.system('bzip2 -c ' + filename + ' > ' + filename + 'z')
            os.system('chmod a+r ' + filename + 'z')
            os.system('rm ' + filename)
            print "  %s: %s"%(filename.split('/')[1], n)
